/*
   PowerART 1.02
   text convertor
   <--
   source: PowerArticle (#?.pa) format
   destination: ANSI-code (default), plain text & AmigaGuide formats
   !-->
   Author: aGGreSSor/tPA; 2002
   Copyright 2002 team PowerAmiga. All Rights Reserved.
*/
OPT OSVERSION=37        ->   - AmigaOS 2.04

/*    DOS */
MODULE 'dos/dos'
/*      */
MODULE 'exec/memory'

/*    */
ENUM ER_DONE,ER_ARGS,
     ER_IN,ER_OUT,ER_READ,
     ER_MEM,ER_SRC,ER_BREAK

/*  */
DEF     inname[256]:STRING,           ->  
        outname[80]:STRING,           ->  
        outline[256]:STRING,          ->   (  =)
        tempstr[10]:STRING,           ->    
        inhandle=NIL,                 ->    
        outhandle=NIL,                ->    
        name: PTR TO LONG,            ->   E-String
        tempname[256]: STRING,	      -> E-String    
        lenadr=0,                     ->   
        memadr:PTR TO CHAR,           ->    
        len2=0,                       ->   
        mem2=0,                       ->    
        count=0, count2=0, count3=0,  ->   3 
        alt=0,                        ->      
        un=0,                         ->  HREF/IMG,   
        linklabel,            ->       HREF
        nodemain=FALSE,       ->         
                              ->   ...
        anivar=0,                     ->   CLI-
        plain=FALSE, quiet=FALSE,      
        guide=FALSE, delete=FALSE,    ->  


        myargs:PTR TO LONG,         ->   
        rdargs


PROC main()
->   , ,  , 
VOID '$VER: PowerArt 1.02 (01.01.03) by aGGreSSor^tPA'

->     Workbench
    IF wbmessage<>0 THEN error(ER_ARGS)

->  
 myargs:=[0,0,0,0,0,0] ->     ...
  IF (rdargs:=ReadArgs('FROM/A,TO,PLAIN/S,GUIDE/S,DEL=DELETE/S,QUIET/S',myargs,NIL))=0 THEN error(ER_ARGS)

->  ,     !     , .
   inname:=myargs[0];  outname:=myargs[1]; plain:=myargs[2]; guide:=myargs[3]
    delete:=myargs[4]; quiet:=myargs[5]

->    
  IF (StrCmp(inname, '?', ALL)) OR ((StrLen(inname))=0) THEN error(ER_ARGS)


->    TO   FROM,  TO  

 IF outname=FALSE
   StrCopy(tempname,inname,StrLen(inname))
  IF guide=TRUE
   outname := StrAdd(tempname,'.guide',ALL)
  ELSEIF plain=TRUE 
   outname := StrAdd(tempname,'.text',ALL)
  ELSE
   outname := StrAdd(tempname,'.ansi',ALL)
  ENDIF
 ENDIF

->    -

  IF guide=TRUE AND plain=TRUE THEN error(ER_ARGS)

->  , ! =)
  IF guide=TRUE THEN plain:=TRUE

->        
  LowerStr(StrCopy(outline, FilePart(inname)))
  IF (InStr(outline, '.pa')<=0) THEN error(ER_SRC)

->    (  )
 IF quiet=FALSE             ->    QUIET -   ?
 WriteF('[1mPowerART:[33m CLI Version [2m1.02 [0m[1m[3maGGreSSor[0m\n')
 WriteF('Copyright  2002 ; team PowerAmiga.\n\n')
 ENDIF 

->   PowerART-
   IF (inhandle:=Open(inname,OLDFILE))=NIL THEN error(ER_IN)  -> ?

->   
      IF quiet=FALSE          ->    QUIET -   ?
      WriteF('File "\s" is processing...\n',inname)->   
      ENDIF
     IF (outhandle:=Open(outname,NEWFILE))=NIL THEN error(ER_OUT) -> ?

 lenadr := FileLength(inname)  ->    
 len2 := lenadr*2              ->       2  

->      ...
 IF (memadr:=AllocMem(lenadr,MEMF_CLEAR))=NIL THEN error(ER_MEM) -> ?
 IF (mem2:=AllocMem(len2,MEMF_CLEAR))=NIL THEN error(ER_MEM)     -> ?

->      
 IF (Read(inhandle,memadr,lenadr))<=0 THEN error(ER_READ)

 convert()               ->       

->    ,    ! =)
 IF plain=FALSE
  outline:='\e[3m-> Generated by PowerART 1.02; aGGreSSor^tPA  2002\e[0m\n\n'
  IF (Write(outhandle,outline,61))<=0 THEN error(ER_OUT)
 ELSEIF guide=TRUE AND plain=TRUE
  outline:='@database team PowerAmiga articles archive\n@remark   Generated by PowerART 1.02; aGGreSSor^tPA  2002\n@width 79\n@wordwrap\n@font \qHiTech.font\q 8\n\n@node main \qPower Article\q\n\n'
  IF (Write(outhandle,outline,172))<=0 THEN error(ER_OUT)
 ELSE
  outline:='-> Generated by PowerART 1.02; aGGreSSor^tPA  2002\n\n'
  IF (Write(outhandle,outline,53))<=0 THEN error(ER_OUT)
 ENDIF
 

->       
 IF (Write(outhandle,mem2,count2))<=0 THEN error(ER_OUT)

->  ,    AmigaGuide

 IF guide=TRUE
  outline:='\n@endnode\n'
  IF (Write(outhandle,outline,10))<=0 THEN error(ER_OUT)
 ENDIF

->   ,     

 IF delete=TRUE
  Close(inhandle)
   StrCopy(tempname,inname,StrLen(inname))
   name := tempname
    DeleteFile(name)
 ENDIF

->   CLI    
 IF quiet=FALSE
  IF plain=FALSE 
   WriteF('\b\b\b[[33m![0m] Converted byte(s): \d/\d\n',lenadr,count2+61)
  ELSEIF guide=TRUE AND plain=TRUE
   WriteF('\b\b\b[[33m![0m] Converted byte(s): \d/\d\n',lenadr,count2+172+10)
  ELSE
   WriteF('\b\b\b[[33m![0m] Converted byte(s): \d/\d\n',lenadr,count2+53)
  ENDIF
 ENDIF

 IF delete=TRUE
  IF quiet=FALSE
   WriteF('\b\b\b[[33m![0m] File "\s" is deleted!\n',inname)
  ENDIF
 ENDIF

 IF tempname=outname
  IF quiet=FALSE
   WriteF('\b\b\b[[33m![0m] New file: "\s"\n',outname)
  ENDIF
 ENDIF

->   
   error(ER_DONE)
ENDPROC


/*     */
PROC error(ernum)
 IF (mem2)   THEN FreeMem(mem2,len2)     ->   ""
 IF (memadr) THEN FreeMem(memadr,lenadr) ->   ""
 IF (outhandle) THEN Close(outhandle)    ->   
	->   
 IF (inhandle) AND delete=FALSE THEN Close(inhandle)
 IF (rdargs) THEN FreeArgs(rdargs)       ->  

->      !
IF quiet=FALSE THEN WriteF('\e[1m') 
 SELECT ernum           ->  
        CASE ER_DONE;   IF quiet=FALSE THEN WriteF('\e[0mAll DONE!')
        CASE ER_ARGS;   WriteF('Wrong arguments!\n')
        CASE ER_IN;     WriteF(' Can''t open file "\s"\n',inname)
        CASE ER_OUT;    WriteF(' Can''t write file "\s"\n',outname)
        CASE ER_READ;   WriteF(' Can''t read file "\s"\n',inname)
        CASE ER_MEM;    WriteF(' Can''t allocate memory!\n')
        CASE ER_SRC;    IF quiet=FALSE THEN WriteF('Wrong source format!\n')
        CASE ER_BREAK;  WriteF('  User aborted! ')
 ENDSELECT
->  ,         CLI  
IF quiet=FALSE THEN WriteF('\e[0m\n\n') 

                                 ->     Workbench...
 IF wbmessage<>0 THEN WriteF('CLI-Only.\nPress return key to close window...')
 CleanUp(ernum) ->   
ENDPROC


/*   PowerART-   ANSI- */ 
PROC convert()

  WHILE (count < lenadr) 

   IF (memadr[count] = "<")
     count3 := 0

    REPEAT
     INC count3

    UNTIL (memadr[count + count3] = ">") OR (memadr[count + count3] = "\n")
      StrCopy(tempstr, memadr + count + 1, 10)  ->   
      UpperStr(tempstr)

      IF InStr(tempstr,'HREF')=0
        alt := 0
       IF guide=FALSE
        REPEAT
         INC count
         IF (memadr[count] = "\q")  ->   
          INC alt
         ENDIF
        UNTIL alt=3
          INC count
          bold(); under(); opty1()
          INC count
 reset(); again(); DEC count2
       ELSE
	REPEAT                      ->  AmigaGuide -
         INC count
        UNTIL (memadr[count]="\q")
         INC count; INC count; linklabel:=count
        REPEAT
         INC count
         IF (memadr[count]="\q") THEN INC alt
	UNTIL alt=2
	 INC count;
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "\q"
        mem2[count2++] := " "
         REPEAT
          mem2[count2] := memadr[count]
          INC count
          INC count2
         UNTIL (memadr[count]="\q")
        mem2[count2++] := " "
        mem2[count2++] := "\q"
        mem2[count2++] := " "
        mem2[count2++] := "l"
        mem2[count2++] := "i"
        mem2[count2++] := "n"
        mem2[count2++] := "k"
        mem2[count2++] := " "
         count:=linklabel
	IF memadr[count-1] = "@" ->     #?.guide
	 REPEAT
          INC count
	 UNTIL (memadr[count]=".")
         REPEAT
          DEC count
         UNTIL (memadr[count]="/")
	  INC count; mem2[count2++] := "\q"
         REPEAT
          mem2[count2] := memadr[count]
	   INC count
 	   INC count2
         UNTIL (memadr[count]=".")
	mem2[count2++] := "."
	mem2[count2++] := "g"
	mem2[count2++] := "u"
	mem2[count2++] := "i"
	mem2[count2++] := "d"
	mem2[count2++] := "e"
	mem2[count2++] := "/"
	mem2[count2++] := "m"
	mem2[count2++] := "a"
	mem2[count2++] := "i"
	mem2[count2++] := "n"
	mem2[count2++] := "\q"
	mem2[count2++] := "}"
	 REPEAT
	  INC count
	 UNTIL (memadr[count]=">")

	ELSE
         opty1()		-> ,  ...
        mem2[count2++] := "}"
         alt := 0
         REPEAT
          INC count
          IF (memadr[count]="\q") THEN INC alt
         UNTIL alt=2

	ENDIF

          INC count;
          DEC count2;

       ENDIF

      ELSEIF InStr(tempstr,'IMG')=0
        alt := 0 
	 IF guide=FALSE
        REPEAT
         INC count
         IF (memadr[count] = "\q")  ->   
          INC alt
         ENDIF
        UNTIL alt=3
          INC count
	  bold(); under(); opty1()
	  INC count; reset(); again(); DEC count2
	 ELSE
	REPEAT                      ->  AmigaGuide -
         INC count
        UNTIL (memadr[count]="\q")
         INC count; linklabel:=count
        REPEAT
         INC count
         IF (memadr[count]="\q") THEN INC alt
	UNTIL alt=2
	 INC count;
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "\q"
        mem2[count2++] := " "
        opty1()
        mem2[count2++] := " "
        mem2[count2++] := "\q"
        mem2[count2++] := " "
        mem2[count2++] := "s"
        mem2[count2++] := "y"
        mem2[count2++] := "s"
        mem2[count2++] := "t"
        mem2[count2++] := "e"
	mem2[count2++] := "m"
	mem2[count2++] := " "
	mem2[count2++] := "\q"
	mem2[count2++] := "M"
	mem2[count2++] := "u"
	mem2[count2++] := "l"
	mem2[count2++] := "t"
	mem2[count2++] := "i"
	mem2[count2++] := "v"
	mem2[count2++] := "i"
	mem2[count2++] := "e"
	mem2[count2++] := "w"
	mem2[count2++] := " "
         count:=linklabel; opty1()
	mem2[count2++] := "\q"
        mem2[count2++] := "}"
         alt := 0
         REPEAT
          INC count
          IF (memadr[count]="\q") THEN INC alt
         UNTIL alt=2
          INC count;
          DEC count2;

	ENDIF


      ELSEIF InStr(tempstr,'/C')=0
          reset(); un := 0
          count := count + count3
          DEC count2

      ELSEIF InStr(tempstr,'/B')=0
          reset(); again()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'/I')=0
          reset(); again()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'/U')=0
          reset(); again()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'/N')=0
          reset(); again()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'#')=0
      
       IF guide=TRUE
         IF nodemain=TRUE
        mem2[count2++] := "\n"
        mem2[count2++] := "@"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := "d"
        mem2[count2++] := "n"
        mem2[count2++] := "o"
        mem2[count2++] := "d"
        mem2[count2++] := "e"
        mem2[count2++] := "\n"
        mem2[count2++] := "@"
        mem2[count2++] := "n"
        mem2[count2++] := "o"
        mem2[count2++] := "d"
        mem2[count2++] := "e"
        mem2[count2++] := " "
        INC count; INC count; opty2()
        mem2[count2++] := "\n"
          INC count; DEC count2
         ELSE
        mem2[count2++] := "\n"
        mem2[count2++] := "\n"
        mem2[count2++] := " "
        mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "\q"
	mem2[count2++] := " "
        mem2[count2++] := "g"
        mem2[count2++] := "o"
        mem2[count2++] := " "
        mem2[count2++] := "t"
        mem2[count2++] := "o"
        mem2[count2++] := " "
        mem2[count2++] := "1"
        mem2[count2++] := "-"
        mem2[count2++] := "s"
        mem2[count2++] := "t"
        mem2[count2++] := " "
        mem2[count2++] := "l"
        mem2[count2++] := "i"
        mem2[count2++] := "n"
        mem2[count2++] := "k"
        mem2[count2++] := " "
        mem2[count2++] := "\q"
        mem2[count2++] := " "
        mem2[count2++] := "l"
        mem2[count2++] := "i"
        mem2[count2++] := "n"
        mem2[count2++] := "k"
        mem2[count2++] := " "
        INC count; INC count
	linklabel := count; opty2()
        mem2[count2++] := "}"
        mem2[count2++] := "\n"

        mem2[count2++] := "\n"
        mem2[count2++] := "@"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := "d"
        mem2[count2++] := "n"
        mem2[count2++] := "o"
        mem2[count2++] := "d"
        mem2[count2++] := "e"
	mem2[count2++] := "\n"
        mem2[count2++] := "@"
        mem2[count2++] := "n"
        mem2[count2++] := "o"
        mem2[count2++] := "d"
        mem2[count2++] := "e"
        mem2[count2++] := " "
        count := linklabel; opty2()
        mem2[count2++] := "\n"
          INC count; DEC count2
  /*        count := count + count3
          DEC count2	*/
         ENDIF
          nodemain := TRUE
       ELSE
          count := count + count3 
          DEC count2
       ENDIF

      ELSEIF InStr(tempstr,'B')=0
          bold()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'I')=0
          ital()
          count := count + count3
          DEC count2

      ELSEIF InStr(tempstr,'U')=0
          under()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'NAME')=0
          green()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'N')=0
          negative()
          count := count + count3     
          DEC count2

      ELSEIF InStr(tempstr,'C1')=0
          white()
          count := count + count3
          DEC count2

      ELSEIF InStr(tempstr,'C2')=0
          blue()
          count := count + count3     
          DEC count2

      ELSE 
       mem2[count2] := memadr[count]
      ENDIF 

   ELSE 
       mem2[count2] := memadr[count]

   ENDIF

    INC count
    INC count2

  ENDWHILE

ENDPROC

/* CLI-, like Unix */

PROC anim()
 IF quiet=FALSE
  IF anivar=4 THEN anivar := 0
   SELECT anivar
    CASE 0; WriteF('\b\b\b[/]')
    CASE 1; WriteF('\b\b\b[-]')
    CASE 2; WriteF('\b\b\b[\\]')
    CASE 3; WriteF('\b\b\b[|]')
   ENDSELECT
  INC anivar
 ENDIF
ENDPROC

/* ASNI styles & AmigaGuide tags */

PROC bold()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "1"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "b"
        mem2[count2++] := "}"
 ENDIF
ENDPROC

PROC ital()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "3"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "i"
        mem2[count2++] := "}"
 ENDIF
ENDPROC

PROC under()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "4"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "u"
        mem2[count2++] := "}"
 ENDIF
ENDPROC

PROC white()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "3"
	mem2[count2++] := "2"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "a"
        mem2[count2++] := "p"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := " "
        mem2[count2++] := "2"
        mem2[count2++] := "}"
 ENDIF
         un := 1
ENDPROC

PROC blue()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "3"
	mem2[count2++] := "3"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "a"
        mem2[count2++] := "p"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := " "
        mem2[count2++] := "3"
        mem2[count2++] := "}"
 ENDIF

        un := 2
ENDPROC

PROC green()			-> AOS3.9 palette
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "3"
	mem2[count2++] := "6"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "a"
        mem2[count2++] := "p"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := " "
        mem2[count2++] := "4"
        mem2[count2++] := "}"
 ENDIF

ENDPROC

PROC reset()
 IF plain = FALSE
	mem2[count2++] := "\e"
	mem2[count2++] := "["
	mem2[count2++] := "0"
	mem2[count2++] := "m"
 ENDIF

 IF guide = TRUE
  IF InStr(tempstr,'/I')=0
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "u"
	mem2[count2++] := "i"
	mem2[count2++] := "}"
  ELSEIF InStr(tempstr,'/B')=0
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "u"
	mem2[count2++] := "b"
	mem2[count2++] := "}"
  ELSEIF InStr(tempstr,'/U')=0
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "u"
	mem2[count2++] := "u"
	mem2[count2++] := "}"
  ELSEIF InStr(tempstr,'/C')=0
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "a"
	mem2[count2++] := "p"
	mem2[count2++] := "e"
	mem2[count2++] := "n"
	mem2[count2++] := " "
	mem2[count2++] := "1"
	mem2[count2++] := "}"
  ELSEIF InStr(tempstr,'/N')=0
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "b"
        mem2[count2++] := "g"
        mem2[count2++] := " "
        mem2[count2++] := "b"
        mem2[count2++] := "a"
        mem2[count2++] := "c"
        mem2[count2++] := "k"
        mem2[count2++] := "}"
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "a"
        mem2[count2++] := "p"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := " "
        mem2[count2++] := "1"
        mem2[count2++] := "}"
  ELSEIF memadr[count-1]="\q"
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "u"
	mem2[count2++] := "u"
	mem2[count2++] := "}"
	mem2[count2++] := "@"
	mem2[count2++] := "{"
	mem2[count2++] := "u"
	mem2[count2++] := "b"
	mem2[count2++] := "}"
  ENDIF
 ENDIF

ENDPROC

PROC negative()
 IF plain = FALSE
        mem2[count2++] := "\e"
        mem2[count2++] := "["
        mem2[count2++] := ";"
        mem2[count2++] := "4"
        mem2[count2++] := "2" 
        mem2[count2++] := "m"
 ENDIF

 IF guide=TRUE
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "b"
        mem2[count2++] := "p"
        mem2[count2++] := "e"
        mem2[count2++] := "n"
        mem2[count2++] := " "
        mem2[count2++] := "3"
        mem2[count2++] := "}"
        mem2[count2++] := "@"
        mem2[count2++] := "{"
        mem2[count2++] := "f"
        mem2[count2++] := "g"
        mem2[count2++] := " "
        mem2[count2++] := "f"
        mem2[count2++] := "i"
        mem2[count2++] := "l"
        mem2[count2++] := "l"
        mem2[count2++] := "t"
        mem2[count2++] := "e"
        mem2[count2++] := "x"
        mem2[count2++] := "t"
        mem2[count2++] := "}"
 ENDIF

ENDPROC

PROC again()
 	SELECT un
	 CASE 1; white()
	 CASE 2; blue() 
	ENDSELECT
 IF quiet = FALSE THEN anim()
 IF CtrlC() THEN error(ER_BREAK)
ENDPROC

PROC opty1()
         REPEAT
          mem2[count2] := memadr[count]
          INC count
          INC count2
         UNTIL (memadr[count]="\q")
ENDPROC

PROC opty2()
         REPEAT
          mem2[count2] := memadr[count]
          INC count
          INC count2
         UNTIL (memadr[count]=">")
ENDPROC
